package org.jboss.chap3.ex1;

import java.security.Security;
import java.util.Properties;
import javax.naming.Context;
import javax.naming.InitialContext;

/** A simple JNDI client that uses HTTPS as the transport. 
 *
 * @author  Scott.Stark@jboss.org
 * @version $Revision: 1.1 $
 */
public class ExClient
{
   public static void main(String args[]) throws Exception
   {
      // Install the Sun JSSE provider since we may not have JSSE installed
      Security.addProvider(new com.sun.net.ssl.internal.ssl.Provider());
      System.out.println("Added JSSE security provider");

      Properties env = new Properties();
      env.setProperty(Context.INITIAL_CONTEXT_FACTORY,
         "org.jboss.naming.HttpNamingContextFactory");
      env.setProperty(Context.PROVIDER_URL,
         "https://localhost:8443/invoker/JNDIFactory");
      Context ctx = new InitialContext(env);
      System.out.println("Created InitialContext, env="+env);
      Object data = ctx.lookup("jmx/rmi/RMIAdaptor");
      System.out.println("lookup(jmx/rmi/RMIAdaptor): "+data);
   }
}

